Index: code/branches/objecthierarchy2/src/orxonox/objects/Radar.cc
===================================================================
--- code/branches/objecthierarchy2/src/orxonox/objects/Radar.cc	(revision 2358)
+++ code/branches/objecthierarchy2/src/orxonox/objects/Radar.cc	(revision 2361)
@@ -99,4 +99,6 @@
     void Radar::tick(float dt)
     {
+        SUPER(Radar, tick, dt);
+
         if (this->focus_ != *(this->itFocus_))
         {
Index: code/branches/objecthierarchy2/src/orxonox/objects/Scene.cc
===================================================================
--- code/branches/objecthierarchy2/src/orxonox/objects/Scene.cc	(revision 2358)
+++ code/branches/objecthierarchy2/src/orxonox/objects/Scene.cc	(revision 2361)
@@ -167,4 +167,6 @@
     void Scene::tick(float dt)
     {
+        SUPER(Scene, tick, dt);
+
         if (!Core::showsGraphics())
         {
Index: code/branches/objecthierarchy2/src/orxonox/objects/gametypes/Gametype.cc
===================================================================
--- code/branches/objecthierarchy2/src/orxonox/objects/gametypes/Gametype.cc	(revision 2358)
+++ code/branches/objecthierarchy2/src/orxonox/objects/gametypes/Gametype.cc	(revision 2361)
@@ -62,4 +62,6 @@
     void Gametype::tick(float dt)
     {
+        SUPER(Gametype, tick, dt);
+
         if (this->bStartCountdownRunning_ && !this->bStarted_)
             this->startCountdown_ -= dt;
@@ -150,7 +152,4 @@
         if (this->spawnpoints_.size() > 0)
         {
-            srand(time(0));
-            rnd();
-
             unsigned int randomspawn = (unsigned int)rnd(this->spawnpoints_.size());
             unsigned int index = 0;
Index: code/branches/objecthierarchy2/src/orxonox/objects/items/Engine.cc
===================================================================
--- code/branches/objecthierarchy2/src/orxonox/objects/items/Engine.cc	(revision 2358)
+++ code/branches/objecthierarchy2/src/orxonox/objects/items/Engine.cc	(revision 2361)
@@ -144,4 +144,6 @@
             return;
 
+        SUPER(Engine, tick, dt);
+
         const Vector3& direction = this->getDirection();
         Vector3 velocity = this->ship_->getVelocity();
Index: code/branches/objecthierarchy2/src/orxonox/objects/worldentities/BlinkingBillboard.cc
===================================================================
--- code/branches/objecthierarchy2/src/orxonox/objects/worldentities/BlinkingBillboard.cc	(revision 2358)
+++ code/branches/objecthierarchy2/src/orxonox/objects/worldentities/BlinkingBillboard.cc	(revision 2361)
@@ -75,4 +75,6 @@
     void BlinkingBillboard::tick(float dt)
     {
+        SUPER(BlinkingBillboard, tick, dt);
+
         if (Core::isMaster() && this->isActive())
         {
Index: code/branches/objecthierarchy2/src/orxonox/objects/worldentities/Camera.cc
===================================================================
--- code/branches/objecthierarchy2/src/orxonox/objects/worldentities/Camera.cc	(revision 2358)
+++ code/branches/objecthierarchy2/src/orxonox/objects/worldentities/Camera.cc	(revision 2361)
@@ -94,4 +94,5 @@
     void Camera::tick(float dt)
     {
+        SUPER(Camera, tick, dt);
 /*
         // this stuff here may need some adjustments
Index: code/branches/objecthierarchy2/src/orxonox/objects/worldentities/ControllableEntity.cc
===================================================================
--- code/branches/objecthierarchy2/src/orxonox/objects/worldentities/ControllableEntity.cc	(revision 2358)
+++ code/branches/objecthierarchy2/src/orxonox/objects/worldentities/ControllableEntity.cc	(revision 2361)
@@ -232,4 +232,6 @@
         if (this->isActive())
         {
+            SUPER(ControllableEntity, tick, dt);
+
             this->velocity_ += (dt * this->acceleration_);
             this->node_->translate(dt * this->velocity_, Ogre::Node::TS_LOCAL);
Index: code/branches/objecthierarchy2/src/orxonox/objects/worldentities/FadingBillboard.cc
===================================================================
--- code/branches/objecthierarchy2/src/orxonox/objects/worldentities/FadingBillboard.cc	(revision 2358)
+++ code/branches/objecthierarchy2/src/orxonox/objects/worldentities/FadingBillboard.cc	(revision 2361)
@@ -140,4 +140,6 @@
     void FadingBillboard::tick(float dt)
     {
+        SUPER(FadingBillboard, tick, dt);
+
         if (this->changedirection_ > 0 && (this->fadedColour_.a < this->getColour().a))
         {
Index: code/branches/objecthierarchy2/src/orxonox/objects/worldentities/MovableEntity.cc
===================================================================
--- code/branches/objecthierarchy2/src/orxonox/objects/worldentities/MovableEntity.cc	(revision 2358)
+++ code/branches/objecthierarchy2/src/orxonox/objects/worldentities/MovableEntity.cc	(revision 2361)
@@ -74,4 +74,6 @@
         if (this->isActive())
         {
+            SUPER(MovableEntity, tick, dt);
+
             this->velocity_ += (dt * this->acceleration_);
             this->node_->translate(dt * this->velocity_);
Index: code/branches/objecthierarchy2/src/orxonox/objects/worldentities/triggers/Trigger.cc
===================================================================
--- code/branches/objecthierarchy2/src/orxonox/objects/worldentities/triggers/Trigger.cc	(revision 2358)
+++ code/branches/objecthierarchy2/src/orxonox/objects/worldentities/triggers/Trigger.cc	(revision 2361)
@@ -106,4 +106,6 @@
     if (!this->BaseObject::isActive())
         return;
+
+    SUPER(Trigger, tick, dt);
 
     bool newTriggered = this->isTriggered() ^ this->bInvertMode_;
Index: code/branches/objecthierarchy2/src/orxonox/overlays/debug/DebugFPSText.cc
===================================================================
--- code/branches/objecthierarchy2/src/orxonox/overlays/debug/DebugFPSText.cc	(revision 2358)
+++ code/branches/objecthierarchy2/src/orxonox/overlays/debug/DebugFPSText.cc	(revision 2361)
@@ -49,4 +49,6 @@
     void DebugFPSText::tick(float dt)
     {
+        SUPER(DebugFPSText, tick, dt);
+
         float fps = GraphicsEngine::getInstance().getAverageFramesPerSecond();
         this->setCaption(convertToString(fps));
Index: code/branches/objecthierarchy2/src/orxonox/overlays/debug/DebugRTRText.cc
===================================================================
--- code/branches/objecthierarchy2/src/orxonox/overlays/debug/DebugRTRText.cc	(revision 2358)
+++ code/branches/objecthierarchy2/src/orxonox/overlays/debug/DebugRTRText.cc	(revision 2361)
@@ -49,4 +49,6 @@
     void DebugRTRText::tick(float dt)
     {
+        SUPER(DebugRTRText, tick, dt);
+
         float rtr = GraphicsEngine::getInstance().getAverageTickTime();
         this->setCaption(convertToString(rtr));
Index: code/branches/objecthierarchy2/src/orxonox/overlays/hud/HUDNavigation.cc
===================================================================
--- code/branches/objecthierarchy2/src/orxonox/overlays/hud/HUDNavigation.cc	(revision 2358)
+++ code/branches/objecthierarchy2/src/orxonox/overlays/hud/HUDNavigation.cc	(revision 2361)
@@ -129,4 +129,6 @@
     void HUDNavigation::tick(float dt)
     {
+        SUPER(HUDNavigation, tick, dt);
+
         if (!Radar::getInstance().getFocus())
         {
Index: code/branches/objecthierarchy2/src/orxonox/overlays/hud/HUDSpeedBar.cc
===================================================================
--- code/branches/objecthierarchy2/src/orxonox/overlays/hud/HUDSpeedBar.cc	(revision 2358)
+++ code/branches/objecthierarchy2/src/orxonox/overlays/hud/HUDSpeedBar.cc	(revision 2361)
@@ -52,4 +52,6 @@
     void HUDSpeedBar::tick(float dt)
     {
+        SUPER(HUDSpeedBar, tick, dt);
+
         if (this->owner_ && this->owner_->getEngine())
         {
Index: code/branches/objecthierarchy2/src/orxonox/tools/Shader.cc
===================================================================
--- code/branches/objecthierarchy2/src/orxonox/tools/Shader.cc	(revision 2358)
+++ code/branches/objecthierarchy2/src/orxonox/tools/Shader.cc	(revision 2361)
@@ -101,4 +101,6 @@
     void Shader::tick(float dt)
     {
+        SUPER(Shader, tick, dt);
+
         if (this->bLoadCompositor_ && !this->bViewportInitialized_ && this->scenemanager_ && this->scenemanager_->getCurrentViewport())
         {