Index: /code/branches/physics/visual_studio/vc8/bullet_collision.vcproj
===================================================================
--- /code/branches/physics/visual_studio/vc8/bullet_collision.vcproj	(revision 2431)
+++ /code/branches/physics/visual_studio/vc8/bullet_collision.vcproj	(revision 2432)
@@ -180,4 +180,8 @@
 				>
 				<File
+					RelativePath="..\..\src\bullet\BulletCollision\CollisionDispatch\btActivatingCollisionAlgorithm.cpp"
+					>
+				</File>
+				<File
 					RelativePath="..\..\src\bullet\BulletCollision\CollisionDispatch\btBoxBoxCollisionAlgorithm.cpp"
 					>
@@ -221,4 +225,8 @@
 				<File
 					RelativePath="..\..\src\bullet\BulletCollision\CollisionDispatch\btEmptyCollisionAlgorithm.cpp"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletCollision\CollisionDispatch\btGhostObject.cpp"
 					>
 				</File>
@@ -389,5 +397,5 @@
 			</Filter>
 			<Filter
-				Name="GIMPACT"
+				Name="Gimpact"
 				>
 				<File
@@ -449,8 +457,4 @@
 				<File
 					RelativePath="..\..\src\bullet\BulletCollision\NarrowPhaseCollision\btGjkConvexCast.cpp"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\bullet\BulletCollision\NarrowPhaseCollision\btGjkEpa.cpp"
 					>
 				</File>
@@ -554,4 +558,8 @@
 				>
 				<File
+					RelativePath="..\..\src\bullet\BulletCollision\CollisionDispatch\btActivatingCollisionAlgorithm.h"
+					>
+				</File>
+				<File
 					RelativePath="..\..\src\bullet\BulletCollision\CollisionDispatch\btBoxBoxCollisionAlgorithm.h"
 					>
@@ -603,4 +611,8 @@
 				<File
 					RelativePath="..\..\src\bullet\BulletCollision\CollisionDispatch\btEmptyCollisionAlgorithm.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletCollision\CollisionDispatch\btGhostObject.h"
 					>
 				</File>
@@ -783,5 +795,5 @@
 			</Filter>
 			<Filter
-				Name="GIMPACT"
+				Name="Gimpact"
 				>
 				<File
@@ -831,4 +843,64 @@
 				<File
 					RelativePath="..\..\src\bullet\BulletCollision\GIMPACT\btTriangleShapeEx.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletCollision\GIMPACT\gim_array.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletCollision\GIMPACT\gim_basic_geometry_operations.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletCollision\GIMPACT\gim_bitset.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletCollision\GIMPACT\gim_box_collision.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletCollision\GIMPACT\gim_box_set.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletCollision\GIMPACT\gim_clip_polygon.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletCollision\GIMPACT\gim_contact.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletCollision\GIMPACT\gim_geom_types.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletCollision\GIMPACT\gim_geometry.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletCollision\GIMPACT\gim_hash_table.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletCollision\GIMPACT\gim_linear_math.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletCollision\GIMPACT\gim_math.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletCollision\GIMPACT\gim_memory.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletCollision\GIMPACT\gim_radixsort.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletCollision\GIMPACT\gim_tri_collision.h"
 					>
 				</File>
@@ -855,8 +927,4 @@
 				<File
 					RelativePath="..\..\src\bullet\BulletCollision\NarrowPhaseCollision\btGjkConvexCast.h"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\bullet\BulletCollision\NarrowPhaseCollision\btGjkEpa.h"
 					>
 				</File>
Index: /code/branches/physics/visual_studio/vc8/bullet_dynamics.vcproj
===================================================================
--- /code/branches/physics/visual_studio/vc8/bullet_dynamics.vcproj	(revision 2431)
+++ /code/branches/physics/visual_studio/vc8/bullet_dynamics.vcproj	(revision 2432)
@@ -208,4 +208,12 @@
 				</File>
 			</Filter>
+			<Filter
+				Name="Character"
+				>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\Character\btKinematicCharacterController.cpp"
+					>
+				</File>
+			</Filter>
 		</Filter>
 		<Filter
@@ -318,4 +326,16 @@
 				</File>
 			</Filter>
+			<Filter
+				Name="Character"
+				>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\Character\btCharacterControllerInterface.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\Character\btKinematicCharacterController.h"
+					>
+				</File>
+			</Filter>
 		</Filter>
 	</Files>
Index: /code/branches/physics/visual_studio/vc8/bullet_linearmath.vcproj
===================================================================
--- /code/branches/physics/visual_studio/vc8/bullet_linearmath.vcproj	(revision 2431)
+++ /code/branches/physics/visual_studio/vc8/bullet_linearmath.vcproj	(revision 2432)
@@ -203,8 +203,4 @@
 			</File>
 			<File
-				RelativePath="..\..\src\bullet\LinearMath\btPoint3.h"
-				>
-			</File>
-			<File
 				RelativePath="..\..\src\bullet\LinearMath\btPoolAllocator.h"
 				>
Index: /code/branches/physics/visual_studio/vc8/orxonox_vc8.sln
===================================================================
--- /code/branches/physics/visual_studio/vc8/orxonox_vc8.sln	(revision 2431)
+++ /code/branches/physics/visual_studio/vc8/orxonox_vc8.sln	(revision 2432)
@@ -13,5 +13,4 @@
 		{F101C2F0-1CB9-4A57-827B-6C399A99B28F} = {F101C2F0-1CB9-4A57-827B-6C399A99B28F}
 		{271715F3-5B90-4110-A552-70C788084A86} = {271715F3-5B90-4110-A552-70C788084A86}
-		{09E86264-CA02-4A60-98EA-61BB3F460160} = {09E86264-CA02-4A60-98EA-61BB3F460160}
 		{C8659D22-3CB7-41C9-A1BC-B40DB70A31A5} = {C8659D22-3CB7-41C9-A1BC-B40DB70A31A5}
 		{41481057-47FD-4BEF-853B-7EF5F975F05E} = {41481057-47FD-4BEF-853B-7EF5F975F05E}
@@ -170,10 +169,4 @@
 EndProject
 Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "bullet_linearmath", "bullet_linearmath.vcproj", "{C8659D22-3CB7-41C9-A1BC-B40DB70A31A5}"
-	ProjectSection(WebsiteProperties) = preProject
-		Debug.AspNetCompiler.Debug = "True"
-		Release.AspNetCompiler.Debug = "False"
-	EndProjectSection
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "bullet_softbody", "bullet_softbody.vcproj", "{09E86264-CA02-4A60-98EA-61BB3F460160}"
 	ProjectSection(WebsiteProperties) = preProject
 		Debug.AspNetCompiler.Debug = "True"
@@ -261,8 +254,4 @@
 		{C8659D22-3CB7-41C9-A1BC-B40DB70A31A5}.Release|Win32.ActiveCfg = Release|Win32
 		{C8659D22-3CB7-41C9-A1BC-B40DB70A31A5}.Release|Win32.Build.0 = Release|Win32
-		{09E86264-CA02-4A60-98EA-61BB3F460160}.Debug|Win32.ActiveCfg = Debug|Win32
-		{09E86264-CA02-4A60-98EA-61BB3F460160}.Debug|Win32.Build.0 = Debug|Win32
-		{09E86264-CA02-4A60-98EA-61BB3F460160}.Release|Win32.ActiveCfg = Release|Win32
-		{09E86264-CA02-4A60-98EA-61BB3F460160}.Release|Win32.Build.0 = Release|Win32
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
@@ -285,5 +274,4 @@
 		{41481057-47FD-4BEF-853B-7EF5F975F05E} = {B9D56701-B4DB-43F8-9920-241CA418C1CE}
 		{C8659D22-3CB7-41C9-A1BC-B40DB70A31A5} = {B9D56701-B4DB-43F8-9920-241CA418C1CE}
-		{09E86264-CA02-4A60-98EA-61BB3F460160} = {B9D56701-B4DB-43F8-9920-241CA418C1CE}
 	EndGlobalSection
 EndGlobal